//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  DodgerBlue
#property indicator_color2  Crimson
#property indicator_color3  Gold
#property indicator_width1  2
#property indicator_width2  2
#property indicator_style3  STYLE_DASH

//
//
//
//
//

extern string TimeFrame        = "Current time frame";
extern int    Price            = 0;
extern double Length           = 100;
extern double Phase            = 0;
extern bool   SmoothDouble     = true;
extern int    LevelBars        = 300;
extern double LevelFactor      = 0.283;
extern bool   ShowText         = true;
extern string TextDir          = "JT Text";
extern int    textXPosition    = 5;
extern int    textYPosition    = 30;
extern color  upTextColor      = Blue;
extern color  dnTextColor      = Red;
extern color  nuTextColor      = Gray;
extern int    upFontSize       = 12;
extern int    dnFontSize       = 12;
extern int    nuFontSize       = 12;
extern bool   Interpolate      = true;

extern string _                = "alerts settings";
extern bool   alertsOn         = true;
extern bool   alertsOnCurrent  = true;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = false;
extern bool   alertsEmail      = false;

extern string  __              = "arrows settings";
extern bool   ShowArrows       = true;
extern string arrowsIdentifier = "JT arrows";
extern color  arrowsUpColor    = Lime;
extern color  arrowsDnColor    = Orange;

//
//
//
//
//

double Upval[];
double Dnval[];
double ItLev[];
double trend[];

//
//
//
//
//

string indicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int init()
{
      IndicatorBuffers(4);
      SetIndexBuffer(0,Upval); SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,Dnval); SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexBuffer(2,ItLev);
      SetIndexBuffer(3,trend);
      
      //
      //
      //
      //
      //
      
      indicatorFileName = WindowExpertName();
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //
      
      IndicatorShortName(timeFrameToString(timeFrame)+"   Jurik Trend ");
   return(0);
}

//
//
//
//
//

int deinit()
{  
   if (!calculateValue && ShowArrows) deleteArrows(); 
   ObjectDelete(TextDir); 
return(0); 
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,n,k,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { Upval[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame==Period())
   {
     for (i=limit-1; i>=0; i--)
     {  
         double ma = iMA(NULL,0,1,0,MODE_SMA,Price,i);
      
          Upval[i] = ma-iDSmooth(iMA(NULL,0,1,0,MODE_SMA,Price,i)         ,Length,Phase,SmoothDouble,i, 0);
          Dnval[i] = - (Low[i] - iDSmooth(iMA(NULL,0,1,0,MODE_SMA,Price,i),Length,Phase,SmoothDouble,i,20)
                     +  High[i]- iDSmooth(iMA(NULL,0,1,0,MODE_SMA,Price,i),Length,Phase,SmoothDouble,i,40));
                     
          double high  = MathMax(Upval[ArrayMaximum(Upval,LevelBars,i)],Dnval[ArrayMaximum(Dnval,LevelBars,i)]);
          ItLev[i] = high*LevelFactor; 
          trend[i] = trend[i+1]; 
         
	       if (Upval[i] > ItLev[i])                        { trend[i] = 1; Commenter(1);  }
	       if (Dnval[i] > ItLev[i])                        { trend[i] =-1; Commenter(-1); }
	       if (Upval[i] < ItLev[i] && Dnval[i] < ItLev[i]) { trend[i] = 0; Commenter(0);  }
	       manageArrow(i);
	      
      }  
      SetLevelValue(0,ItLev[0]);
      manageAlerts();
    return(0);
    }

    //
    //
    //
    //
    //
  
    limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
    for (i=limit;i>=0; i--)
    {
       int y = iBarShift(NULL,timeFrame,Time[i]);
            Upval[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Price,Length,Phase,SmoothDouble,LevelBars,LevelFactor,ShowText,TextDir,textXPosition,textYPosition,upTextColor,dnTextColor,nuTextColor,upFontSize,dnFontSize,nuFontSize,0,y);
            Dnval[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Price,Length,Phase,SmoothDouble,LevelBars,LevelFactor,ShowText,TextDir,textXPosition,textYPosition,upTextColor,dnTextColor,nuTextColor,upFontSize,dnFontSize,nuFontSize,1,y);
            ItLev[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Price,Length,Phase,SmoothDouble,LevelBars,LevelFactor,ShowText,TextDir,textXPosition,textYPosition,upTextColor,dnTextColor,nuTextColor,upFontSize,dnFontSize,nuFontSize,2,y);
            trend[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Price,Length,Phase,SmoothDouble,LevelBars,LevelFactor,ShowText,TextDir,textXPosition,textYPosition,upTextColor,dnTextColor,nuTextColor,upFontSize,dnFontSize,nuFontSize,3,y);
            manageArrow(i);
            
            //
            //
            //
            //
            //
            
            if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

            //
            //
            //
            //
            //

            datetime time = iTime(NULL,timeFrame,y);
            for(n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(k = 1; k < n; k++)
            {
  	            Upval[i+k] = Upval[i] + (Upval[i+n] - Upval[i]) * k/n;
  	            Dnval[i+k] = Dnval[i] + (Dnval[i+n] - Dnval[i]) * k/n;
  	            ItLev[i+k] = ItLev[i] + (ItLev[i+n] - ItLev[i]) * k/n;
           }  	            
   }   
   manageAlerts();   
return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"buy");
         if (trend[whichBar] ==-1) doAlert(whichBar,"sell");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," - ",timeFrameToString(timeFrame)+" jurik trend ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," jurik trend "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//
//
//
//
//

double wrk[][60];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iDSmooth(double price, double length, double phase, bool isDouble, int i, int s=0)
{
   if (isDouble)
         return (iSmooth(iSmooth(price,MathSqrt(length),phase,i,s),MathSqrt(length),phase,i,s+10));
   else  return (iSmooth(price,length,phase,i,s));
}

//
//
//
//
//

double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}

//
//
//
//
//

void manageArrow(int i)
{
   if (!calculateValue && ShowArrows)
   {
      deleteArrow(Time[i]);
      if (trend[i]!=trend[i+1])
      {
         if (trend[i] == 1) drawArrow(i,arrowsUpColor,241,false);
         if (trend[i] ==-1) drawArrow(i,arrowsDnColor,242,true);
      }
   }
}               

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,bool up)
{
   string name = arrowsIdentifier+":"+Time[i];
   double gap  = 3.0*iATR(NULL,0,20,i)/4.0;   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
  
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i]+gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i] -gap);
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

//
//
//
//
//

void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}

//
//
//
//
//

void Commenter(int Dir) 
{
    if (ShowText)
    {
      ObjectCreate(TextDir,OBJ_LABEL,0,0,0);
         ObjectSet(TextDir,OBJPROP_XDISTANCE,textXPosition);
         ObjectSet(TextDir,OBJPROP_YDISTANCE,textYPosition);
         if (Dir == 1) ObjectSetText(TextDir, "Buy", upFontSize,"Arial Black",upTextColor);
         if (Dir ==-1) ObjectSetText(TextDir, "Sell",dnFontSize,"Arial Black",dnTextColor);
         if (Dir == 0) ObjectSetText(TextDir, "Wait",nuFontSize,"Arial Black",nuTextColor);
    }
   
return; 
}

